#define kissinger2pngread
#include "pnghexreadwrite.cpp"
#include <iomanip>
/*
Kissinger 2 character counter and find missing script
Piotr Grochowski, piotrunio-2004@wp.pl

This is free and unencumbered software released into the public domain.

Anyone is free to copy, modify, publish, use, compile, sell, or
distribute this software, either in source code form or as a compiled
binary, for any purpose, commercial or non-commercial, and by any
means.

In jurisdictions that recognize copyright laws, the author or authors
of this software dedicate any and all copyright interest in the
software to the public domain. We make this dedication for the benefit
of the public at large and to the detriment of our heirs and
successors. We intend this dedication to be an overt act of
relinquishment in perpetuity of all present and future rights to this
software under copyright law.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY CLAIM, DAMAGES OR
OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.

For more information, please refer to <http://unlicense.org/>
*/
std::vector<int> charset = {
};
// insert the character set to find, for example from codepagedatabase.cpp
int main(){
	pnghexread();
	std::vector<bool> bits; bits.resize(65536*17);
	for(int i=0; i<bits.size(); i++) bits[i]=0;
	for(int i=0; i<charset.size(); i++) bits[charset[i]]=1;
	//for(int i=0; i<(sizeof utf/sizeof(int)); i++) bits[utf[i]]=1;
	//for(int i=0; i<(sizeof utf1/sizeof(int)); i++) bits[utf1[i]]=1;
	//for(int i=0; i<(sizeof utf2/sizeof(int)); i++) bits[utf2[i]]=1;
	std::vector<bool> bits2; bits2.resize(65536*17);
	for(int i=0; i<bits2.size(); i++) bits2[i]=0;
	for(int i=0; i<hchar.size(); i++) bits2[hchar[i]]=1;
	std::vector<bool> bits3; bits3.resize(65536*17);
	for(int i=0; i<bits3.size(); i++) bits3[i]=0;
	for(int i=0; i<fchar.size(); i++) bits3[fchar[i]]=1;
	int fcount = 0; int hcount = 0; int bcount = 0; int ocount = 0;
	for(int z=0; z<65536*17; z++){
		if(z<0x20||(z>=0x7F&&z<=0x9F)) continue;
		hcount+=bits2[z]; fcount+=bits3[z]; bcount+=bits2[z]|bits3[z]; ocount+=bits2[z]&bits3[z];
	}
	std::cout << "halfwidth: " << hcount << ", fullwidth: " << fcount << ", both: " << bcount << ", overlap: " << ocount << "\n";
	int mcount = 0;
	for(int i=0; i<65536*17; i++){
		if(bits[i]&&!bits2[i]){ //find missing in halfwidth
		//if(bits[i]&&!bits2[i]&&!bits3[i]){ //find missing in both
		//if(bits[i]&&!bits3[i]){ //find missing in fullwidth
			mcount++;
			std::cout << std::hex << std::setfill('0') << std::setw(4) << i << " ";
		}
	}
	std::cout << "\nmissing: " << std::dec << mcount << "\n";
	return 0;
}