#ifdef kissinger2pngread
#define STB_IMAGE_IMPLEMENTATION
#include "stb_image.cpp"
#endif
#ifdef kissinger2pngwrite
#define STB_IMAGE_WRITE_IMPLEMENTATION
#include "stb_image_write.cpp"
#endif
#include <iostream>
#include <fstream>
#include <vector>
#include <stdint.h>
/*
Kissinger 2 hex and png read/write utilities
Piotr Grochowski, piotrunio-2004@wp.pl

This is free and unencumbered software released into the public domain.

Anyone is free to copy, modify, publish, use, compile, sell, or
distribute this software, either in source code form or as a compiled
binary, for any purpose, commercial or non-commercial, and by any
means.

In jurisdictions that recognize copyright laws, the author or authors
of this software dedicate any and all copyright interest in the
software to the public domain. We make this dedication for the benefit
of the public at large and to the detriment of our heirs and
successors. We intend this dedication to be an overt act of
relinquishment in perpetuity of all present and future rights to this
software under copyright law.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY CLAIM, DAMAGES OR
OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.

For more information, please refer to <http://unlicense.org/>
*/
		const char* hex = "0123456789ABCDEFGHIJKL";
		std::vector<int> iih = {0,1,2,3,4,7,8,9,10,};
		std::vector<int> iif = {0,1,2,3,4,5,6,7,8,9,14,15,16,17,18,19,20,21};
		const int subplanes = 9;
	std::vector<uint64_t> hdata = {};
	std::vector<uint64_t> fdata = {};
	std::vector<uint32_t> hchar = {};
	std::vector<uint32_t> fchar = {};
void hexread(){
	hdata.clear();fdata.clear();hchar.clear();fchar.clear();
	std::fstream hexfile;
 char a[] = "hex/kissinger2hdata0.hex";
 for(int i=0; i<iih.size(); i++){
  a[19]=hex[iih[i]];
  hexfile.open(a, std::ios::in|std::ios::binary);
    hexfile.seekg (0, hexfile.end);
    long long length = (long long)hexfile.tellg ();
    hexfile.seekg (0, hexfile.beg);
	int ii = 0;
    while(ii<length){
		int a = 0;
		char z;
		while(ii<length){
			ii++;
			hexfile.read((char*)&z, 1);
			if(z>='0'&&z<='9') z-='0';
			else if(z>='A'&&z<='F') z-=('A'-10);
			else if(z>='a'&&z<='f') z-=('a'-10);
			else break;
			a=(a<<4)|z;
		}
		if(z==':'){
			uint64_t q = 0;
			int b = 0;
			while(b<32){
				if(ii>=length)break;
				ii++;
				hexfile.read((char*)&z, 1);
				if(z>='0'&&z<='9') z-='0';
				else if(z>='A'&&z<='F') z-=('A'-10);
				else if(z>='a'&&z<='f') z-=('a'-10);
				else break;
				z=((z&3)<<2)|((z&12)>>2);
				z=((z&5)<<1)|((z&10)>>1);
				q|=(uint64_t)z<<((b*4)&63);
				b++;
				if(!(b&15)) {hdata.push_back(q);q=0;}
			}
			hchar.push_back(a);
		}
		else if(z==';'); //comments
		else;
		while(ii<length&&z!=10) 
			{ii++;hexfile.read((char*)&z, 1);}
	}
  hexfile.close();
 }
 char b[] = "hex/kissinger2fdata0.hex";
 for(int i=0; i<iif.size(); i++){
  b[19]=hex[iif[i]];
  hexfile.open(b, std::ios::in|std::ios::binary);
    hexfile.seekg (0, hexfile.end);
    long long length = (long long)hexfile.tellg ();
    hexfile.seekg (0, hexfile.beg);
	int ii = 0;
    while(ii<length){
		int a = 0;
		char z;
		while(ii<length){
			ii++;
			hexfile.read((char*)&z, 1);
			if(z>='0'&&z<='9') z-='0';
			else if(z>='A'&&z<='F') z-=('A'-10);
			else if(z>='a'&&z<='f') z-=('a'-10);
			else break;
			a=(a<<4)|z;
		}
		if(z==':'){
			uint64_t q = 0;
			int b = 0;
			while(b<64){
				if(ii>=length)break;
				ii++;
				hexfile.read((char*)&z, 1);
				if(z>='0'&&z<='9') z-='0';
				else if(z>='A'&&z<='F') z-=('A'-10);
				else if(z>='a'&&z<='f') z-=('a'-10);
				else break;
				z=((z&3)<<2)|((z&12)>>2);
				z=((z&5)<<1)|((z&10)>>1);
				q|=(uint64_t)z<<((b*4)&63);
				b++;
				if(!(b&15)) {fdata.push_back(q);q=0;}
			}
			fchar.push_back(a);
		}
		else;
		while(ii<length&&z!=10) 
			{ii++;hexfile.read((char*)&z, 1);}
	}
  hexfile.close();
 }
}
#ifdef kissinger2pngread
void pngread(){
	hdata.clear();fdata.clear();hchar.clear();fchar.clear();
	int* imagef;
	int* imageh;
	imagef = (int*)malloc(2048*(2048*subplanes)*sizeof(int));
	imageh = (int*)malloc(1024*(2048*subplanes)*sizeof(int));
	{
		char f[] = "png/kissinger2htest0.png";
		unsigned char* b;
		for(int i=0; i<iih.size(); i++){
			f[19]=hex[iih[i]];
  int width, height, n;
  b = stbi_load(f, &width, &height, &n, 4);
  for(int j=0; j<1024*2048*4; j++) ((char*)(imageh))[i*4*1024*2048+j]=b[j];
		}
	}
	{
		char f[] = "png/kissinger2ftest0.png";
		unsigned char* b;
		for(int i=0; i<iif.size(); i++){
			f[19]=hex[iif[i]];
  int width, height, n;
  b = stbi_load(f, &width, &height, &n, 4);
  for(int j=0; j<1024*2048*4; j++) ((char*)(imagef))[i*4*1024*2048+j]=b[j];
		}
	}
	for(int z=0; z<16384*subplanes; z++){
		int e = (iih[z>>14]<<14)|(z&16383);
		int x = (z&0x7F)* 8+((z>>7)*16)*1024;
		int c = (z&0x7F)*16+((z>>7)*16)*2048;
		bool hashalfwidth = (imageh[x]&0xFF)==((imageh[x]>>8)&0xFF)&&(imageh[x]&0xFF)==((imageh[x]>>16)&0xFF);
		bool hasfullwidth = (imagef[c]&0xFF)==((imagef[c]>>8)&0xFF)&&(imagef[c]&0xFF)==((imagef[c]>>16)&0xFF);
		if(hashalfwidth){
			uint64_t q[2] = {0,0,};
			for(int i=0; i<128; i++){
				q[i>>6]|=(uint64_t)((imageh[x+(i&7)+(i>>3)*1024]&0xFFFFFF)==0x000000)<<(i&63);
			}
			hdata.push_back(q[0]);
			hdata.push_back(q[1]);
			hchar.push_back(e);
		}
		if(hasfullwidth){
			uint64_t q[4] = {0,0,0,0,};
			for(int i=0; i<256; i++){
				q[i>>6]|=(uint64_t)((imagef[c+(i&15)+(i>>4)*2048]&0xFFFFFF)==0x000000)<<(i&63);
			}
			fdata.push_back(q[0]);
			fdata.push_back(q[1]);
			fdata.push_back(q[2]);
			fdata.push_back(q[3]);
			fchar.push_back(e);
		}
	}
	free(imagef);free(imageh);
}
void pnghexread(){
	std::cout << "Select png or hex read (p/h)\n";
	char a; std::cin >> a;
	if(a=='p'|a=='P') pngread();
	else if(a=='h'|a=='H') hexread();
	else exit(0);
}
#endif
void hexwrite(){
std::string hexunlicense = "\
;This is free and unencumbered software released into the public domain.\n\
;\n\
;Anyone is free to copy, modify, publish, use, compile, sell, or\n\
;distribute this software, either in source code form or as a compiled\n\
;binary, for any purpose, commercial or non-commercial, and by any\n\
;means.\n\
;\n\
;In jurisdictions that recognize copyright laws, the author or authors\n\
;of this software dedicate any and all copyright interest in the\n\
;software to the public domain. We make this dedication for the benefit\n\
;of the public at large and to the detriment of our heirs and\n\
;successors. We intend this dedication to be an overt act of\n\
;relinquishment in perpetuity of all present and future rights to this\n\
;software under copyright law.\n\
;\n\
;THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND,\n\
;EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF\n\
;MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.\n\
;IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY CLAIM, DAMAGES OR\n\
;OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,\n\
;ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR\n\
;OTHER DEALINGS IN THE SOFTWARE.\n\
;\n\
;For more information, please refer to <http://unlicense.org/>\n\
";
std::string kissinger2hnotice = ";contributors: Piotr Grochowski (piotrunio-2004@wp.pl)\n;\n"+hexunlicense;
std::string kissinger2fnotice = ";contributors: Piotr Grochowski (piotrunio-2004@wp.pl)\n;includes glyphs from Shinonome 16, izmg16-2004-1, izmg16-2004-2, and jisksp16-1990 (modified)\n;\n"+hexunlicense;
	std::vector<std::string> hexh = {};
	std::vector<std::string> hexf = {};
	hexh.resize(iih.size(),kissinger2hnotice);
	hexf.resize(iif.size(),kissinger2fnotice);
	for(int i=0; i<hchar.size(); i++){
		int z = -1;
		for(int k=0; k<iih.size(); k++) if(iih[k]==hchar[i]>>14) z=k;
		if(z<0){std::cout << "Missing halfwidth subplane " << (hchar[i]>>14) << "\n"; exit(1);}
   std::string q = "";
   uint32_t encoding = hchar[i];
   if(encoding>>28) q.push_back(hex[(encoding>>28)&0xF]);
   if(encoding>>24) q.push_back(hex[(encoding>>24)&0xF]);
   if(encoding>>20) q.push_back(hex[(encoding>>20)&0xF]);
   if(encoding>>16) q.push_back(hex[(encoding>>16)&0xF]);
   q.push_back(hex[(encoding>>12)&0xF]);
   q.push_back(hex[(encoding>> 8)&0xF]);
   q.push_back(hex[(encoding>> 4)&0xF]);
   q.push_back(hex[(encoding>> 0)&0xF]);
   q.push_back(':');
   for(int j=0; j<32; j++){
    int w = 0;
    for(int a=0; a<4; a++){
     w<<=1; w|=((hdata[i*2+(j>>4)]>>((j*4+a)&63))&1);
    }
    q.push_back(hex[w]);
   }
   q.push_back('\n');
   hexh[z].append(q);
	}
	for(int i=0; i<fchar.size(); i++){
		int z = -1;
		for(int k=0; k<iif.size(); k++) if(iif[k]==fchar[i]>>13) z=k;
		if(z<0){std::cout << "Missing fullwidth subplane " << (fchar[i]>>13) << "\n"; exit(1);}
   std::string q = "";
   uint32_t encoding = fchar[i];
   if(encoding>>28) q.push_back(hex[(encoding>>28)&0xF]);
   if(encoding>>24) q.push_back(hex[(encoding>>24)&0xF]);
   if(encoding>>20) q.push_back(hex[(encoding>>20)&0xF]);
   if(encoding>>16) q.push_back(hex[(encoding>>16)&0xF]);
   q.push_back(hex[(encoding>>12)&0xF]);
   q.push_back(hex[(encoding>> 8)&0xF]);
   q.push_back(hex[(encoding>> 4)&0xF]);
   q.push_back(hex[(encoding>> 0)&0xF]);
   q.push_back(':');
   for(int j=0; j<64; j++){
    int w = 0;
    for(int a=0; a<4; a++){
     w<<=1; w|=((fdata[i*4+(j>>4)]>>((j*4+a)&63))&1);
    }
    q.push_back(hex[w]);
   }
   q.push_back('\n');
   hexf[z].append(q);
	}
	for(int i=0; i<hexh.size(); i++) if(hexh[i]==kissinger2hnotice) hexh[i].clear();
	for(int i=0; i<hexf.size(); i++) if(hexf[i]==kissinger2fnotice) hexf[i].clear();
	std::fstream output;
 char a[] = "hex/kissinger2hdata0.hex";
 for(int i=0; i<iih.size(); i++){
  a[19]=hex[iih[i]];
  output.open(a, std::ios::out|std::ios::binary);
  output.write((char*)&hexh[i][0], hexh[i].size());
  output.close();
 }
 char b[] = "hex/kissinger2fdata0.hex";
 for(int i=0; i<iif.size(); i++){
  b[19]=hex[iif[i]];
  output.open(b, std::ios::out|std::ios::binary);
  output.write((char*)&hexf[i][0], hexf[i].size());
  output.close();
 }
 std::cout << "DONE\n";
}
#ifdef kissinger2pngwrite
void pngwrite(){
	int* imagef;
	int* imageh;
	imagef = (int*)malloc(2048*(2048*subplanes)*sizeof(int));
	imageh = (int*)malloc(1024*(2048*subplanes)*sizeof(int));
	for(int z=0; z<16384*subplanes; z++){
		int colour = (((z>>0)&1)^((z>>7)&1))?0xFF999966:0xFFCCCC99;
		if(z<0x20||(z>=0x7F&&z<=0x9F)) colour = (((z>>0)&1)^((z>>7)&1))?0xFFCC99CC:0xFFFFCCFF;
		for(int i=0; i<16; i++) for(int j=0; j<8; j++) {
			imageh[(i+16*(z>>7))*1024+((z&127)* 8+j)] = colour;
		}	
		for(int i=0; i<16; i++) for(int j=0; j<16; j++) {
			imagef[(i+16*(z>>7))*2048+((z&127)*16+j)] = colour;
		}
	}
	for(int i=0; i<hchar.size(); i++){
		int z = hchar[i]&0x3FFF;
		for(int k=0; k<iih.size(); k++) if(iih[k]==hchar[i]>>14) z|=(k<<14);
		if(hchar[i]>>14!=0&&z>>14==0){std::cout << "Missing halfwidth subplane " << (hchar[i]>>14) << "\n"; exit(1);}
		int bg = (((z>>0)&1)^((z>>7)&1))?0xFFCCCCCC:0xFFFFFFFF;
		int fg = 0xFF000000;
		for(int k=0; k<16; k++) for(int j=0; j< 8; j++) {
			imageh[(k+16*(z>>7))*1024+((z&127)* 8+j)] = ((hdata[i*2+(k>>3)]>>((k*8+j)&63))&1)?fg:bg;
		}
		int colour = (((z>>0)&1)^((z>>7)&1))?0xFF9999CC:0xFFCCCCFF;
		for(int k=0; k<16; k++) for(int j=0; j<16; j++) {
			imagef[(k+16*(z>>7))*2048+((z&127)*16+j)] = colour;
		}
	}
	for(int i=0; i<fchar.size(); i++){
		int z = fchar[i]&0x1FFF;
		for(int k=0; k<iif.size(); k++) if(iif[k]==fchar[i]>>13) z|=(k<<13);
		if(fchar[i]>>13!=0&&z>>13==0){std::cout << "Missing fullwidth subplane " << (fchar[i]>>13) << "\n"; exit(1);}
		int bg = (((z>>0)&1)^((z>>7)&1))?0xFFCCCCCC:0xFFFFFFFF;
		int fg = 0xFF000000;
		for(int k=0; k<16; k++) for(int j=0; j<16; j++) {
			imagef[(k+16*(z>>7))*2048+((z&127)*16+j)] = ((fdata[i*4+(k>>2)]>>((k*16+j)&63))&1)?fg:bg;
		}
		int x = (z&0x7F)* 8+((z>>7)*16)*1024;
		bool hashalfwidth = ((imageh[x]>>0)&0xFF)==((imageh[x]>>8)&0xFF)&&((imageh[x]>>0)&0xFF)==((imageh[x]>>16)&0xFF);
		if(!hashalfwidth){
			int colour = (((z>>0)&1)^((z>>7)&1))?0xFF9999CC:0xFFCCCCFF;
			for(int k=0; k<16; k++) for(int j=0; j< 8; j++) {
				imageh[(k+16*(z>>7))*1024+((z&127)* 8+j)] = colour;
			}
		}
	}
	char a[] = "png/kissinger2ftest0.png";
	for(int i=0; i<iif.size(); i++){
		a[19]=hex[iif[i]];
		stbi_write_png(a,2048,1024,4,(char*)(imagef+(2048*1024*i)),2048*4);
	}
	char b[] = "png/kissinger2htest0.png";
	for(int i=0; i<iih.size(); i++){
		b[19]=hex[iih[i]];
		stbi_write_png(b,1024,2048,4,(char*)(imageh+(1024*2048*i)),1024*4);
	}
	std::cout << "DONE";
	free(imagef);free(imageh);
}
void pnghexwrite(){
	std::cout << "Select png or hex write (p/h)\n";
	char a; std::cin >> a;
	if(a=='p'|a=='P') pngwrite();
	else if(a=='h'|a=='H') hexwrite();
	else exit(0);
}
#endif
