#define kissinger2pngread
#include "pnghexreadwrite.cpp"
/*
Kissinger 2 convert to bdf script
Piotr Grochowski, piotrunio-2004@wp.pl

This is free and unencumbered software released into the public domain.

Anyone is free to copy, modify, publish, use, compile, sell, or
distribute this software, either in source code form or as a compiled
binary, for any purpose, commercial or non-commercial, and by any
means.

In jurisdictions that recognize copyright laws, the author or authors
of this software dedicate any and all copyright interest in the
software to the public domain. We make this dedication for the benefit
of the public at large and to the detriment of our heirs and
successors. We intend this dedication to be an overt act of
relinquishment in perpetuity of all present and future rights to this
software under copyright law.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY CLAIM, DAMAGES OR
OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.

For more information, please refer to <http://unlicense.org/>
*/
#include <string>
#include <sstream>
#include <iostream>
#include <fstream>
#include <vector>
#define COPYRIGHTH "public domain - contributors: Piotr Grochowski (piotrunio-2004@wp.pl)"
#define COPYRIGHTF COPYRIGHTH
std::string bdfh = "STARTFONT 2.1\nCOMMENT \"This is the halfwidth of Kissinger 2, the successor of Kissinger and competitor of U***ont.\"\nFONT -Type Design-Kissinger 2-Regular-R-Normal--16-167-96-96-C-80-ISO10646-1\nSIZE 16 96 96\nFONTBOUNDINGBOX 8 16 0 -8\nSTARTPROPERTIES 33\nFOUNDRY \"Type Design\"\nFAMILY_NAME \"Kissinger 2\"\nWEIGHT_NAME \"Regular\"\nSLANT \"R\"\nSETWIDTH_NAME \"Normal\"\nADD_STYLE_NAME \"\"\nPIXEL_SIZE 16\nPOINT_SIZE 167\nRESOLUTION_X 96\nRESOLUTION_Y 96\nSPACING \"C\"\nAVERAGE_WIDTH 80\nCHARSET_REGISTRY \"ISO10646\"\nCHARSET_ENCODING \"1\"\nFONTNAME_REGISTRY \"\"\nFONT_NAME \"Kissinger2\"\nFACE_NAME \"Kissinger 2\"\nCOPYRIGHT \"" COPYRIGHTH "\"\nFONT_VERSION \"\"\nFONT_ASCENT 8\nFONT_DESCENT 8\nUNDERLINE_POSITION -7\nUNDERLINE_THICKNESS 1\nX_HEIGHT 8\nCAP_HEIGHT 10\nRAW_ASCENT 500\nRAW_DESCENT 500\nNORM_SPACE 8\nRELATIVE_WEIGHT 40\nRELATIVE_SETWIDTH 50\nFIGURE_WIDTH 8\nAVG_LOWERCASE_WIDTH 80\nAVG_UPPERCASE_WIDTH 80\nENDPROPERTIES\n";
std::string bdff = "STARTFONT 2.1\nCOMMENT \"This is the fullwidth of Kissinger 2, the successor of Kissinger and competitor of U***ont.\"\nFONT -Type Design-Kissinger 2f-Regular-R-Normal--16-167-96-96-C-160-ISO10646-1\nSIZE 16 96 96\nFONTBOUNDINGBOX 16 16 0 -8\nSTARTPROPERTIES 33\nFOUNDRY \"Type Design\"\nFAMILY_NAME \"Kissinger 2f\"\nWEIGHT_NAME \"Regular\"\nSLANT \"R\"\nSETWIDTH_NAME \"Normal\"\nADD_STYLE_NAME \"\"\nPIXEL_SIZE 16\nPOINT_SIZE 167\nRESOLUTION_X 96\nRESOLUTION_Y 96\nSPACING \"C\"\nAVERAGE_WIDTH 160\nCHARSET_REGISTRY \"ISO10646\"\nCHARSET_ENCODING \"1\"\nFONTNAME_REGISTRY \"\"\nFONT_NAME \"Kissinger2f\"\nFACE_NAME \"Kissinger 2f\"\nCOPYRIGHT \"" COPYRIGHTF "\"\nFONT_VERSION \"\"\nFONT_ASCENT 8\nFONT_DESCENT 8\nUNDERLINE_POSITION -7\nUNDERLINE_THICKNESS 1\nX_HEIGHT 8\nCAP_HEIGHT 10\nRAW_ASCENT 500\nRAW_DESCENT 500\nNORM_SPACE 16\nRELATIVE_WEIGHT 40\nRELATIVE_SETWIDTH 50\nFIGURE_WIDTH 16\nAVG_LOWERCASE_WIDTH 160\nAVG_UPPERCASE_WIDTH 160\nENDPROPERTIES\n";
struct glyph{
 std::string name = "uni";
 int encoding;
 int swidth = 500;
 int dwidth = 8;
 int bbx[4] = {8,16,0,-8,};
 std::string bitmap = "";
};
std::vector<glyph> qqh;
std::vector<glyph> qqf;
std::fstream input;
std::fstream output;
int main(){
	pnghexread();
  for(int i=0; i<hchar.size(); i++){
   glyph q;
   q.encoding = hchar[i];
   if(q.encoding>>16) {q.name="u";if(q.encoding>>20)q.name.push_back(hex[(q.encoding>>20)&0xF]);
   q.name.push_back(hex[(q.encoding>>16)&0xF]); }
   q.name.push_back(hex[(q.encoding>>12)&0xF]);
   q.name.push_back(hex[(q.encoding>> 8)&0xF]);
   q.name.push_back(hex[(q.encoding>> 4)&0xF]);
   q.name.push_back(hex[(q.encoding>> 0)&0xF]);
   if(hchar[i]==0) {q.encoding=-1; q.name=".notdef";}
   for(int j=0; j<32; j++){
    int w = 0;
    for(int a=0; a<4; a++){
     w<<=1; w|=((hdata[i*2+(j>>4)]>>((j*4+a)&63))&1);
    }
    q.bitmap.push_back(hex[w]);
    if((j&1)==1)q.bitmap.push_back('\n');
   }
   qqh.push_back(q);
  }
  for(int i=0; i<fchar.size(); i++){
   glyph q;
   q.swidth = 1000;
   q.dwidth = 16;
   q.bbx[0] = 16;
   q.encoding = fchar[i];
   if(q.encoding>>16) {q.name="u";if(q.encoding>>20)q.name.push_back(hex[(q.encoding>>20)&0xF]);
   q.name.push_back(hex[(q.encoding>>16)&0xF]); }
   q.name.push_back(hex[(q.encoding>>12)&0xF]);
   q.name.push_back(hex[(q.encoding>> 8)&0xF]);
   q.name.push_back(hex[(q.encoding>> 4)&0xF]);
   q.name.push_back(hex[(q.encoding>> 0)&0xF]);
   if(fchar[i]==0) {q.encoding=-1; q.name=".notdef";}
   for(int j=0; j<64; j++){
    int w = 0;
    for(int a=0; a<4; a++){
     w<<=1; w|=((fdata[i*4+(j>>4)]>>((j*4+a)&63))&1);
    }
    q.bitmap.push_back(hex[w]);
    if((j&3)==3)q.bitmap.push_back('\n');
   }
   qqf.push_back(q);
  }
 {
 std::stringstream s;
 s << "CHARS " << qqh.size() << '\n';
 for(int i=0; i<qqh.size(); i++){
  s << "STARTCHAR " << qqh[i].name << '\n';
  s << "ENCODING " << qqh[i].encoding << '\n';
  s << "SWIDTH " << qqh[i].swidth << " 0\n";
  s << "DWIDTH " << qqh[i].dwidth << " 0\n";
  s << "BBX " << qqh[i].bbx[0] << ' ' << qqh[i].bbx[1] << ' ' << qqh[i].bbx[2] << ' ' << qqh[i].bbx[3] << '\n';
  s << "BITMAP\n" << qqh[i].bitmap;
  s << "ENDCHAR\n";
 }
 s << "ENDFONT\n";
 bdfh.append(s.str());
 }
 {
 std::stringstream s;
 s << "CHARS " << qqf.size() << '\n';
 for(int i=0; i<qqf.size(); i++){
  s << "STARTCHAR " << qqf[i].name << '\n';
  s << "ENCODING " << qqf[i].encoding << '\n';
  s << "SWIDTH " << qqf[i].swidth << " 0\n";
  s << "DWIDTH " << qqf[i].dwidth << " 0\n";
  s << "BBX " << qqf[i].bbx[0] << ' ' << qqf[i].bbx[1] << ' ' << qqf[i].bbx[2] << ' ' << qqf[i].bbx[3] << '\n';
  s << "BITMAP\n" << qqf[i].bitmap;
  s << "ENDCHAR\n";
 }
 s << "ENDFONT\n";
 bdff.append(s.str());
 }
 output.open("kissinger2test.bdf", std::ios::out|std::ios::binary);
 output.write((char*)&bdfh[0], bdfh.size());
 output.close();
 output.open("kissinger2ftest.bdf", std::ios::out|std::ios::binary);
 output.write((char*)&bdff[0], bdff.size());
 output.close();
 std::cout << "DONE";
}